Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 1940)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 1942)
@@ -924,84 +297,134 @@
 }
 
-
-
-void
-QtGlRendererWidget::SetupProjection(const int w, const int h, const float angle)
-{
-  if (!mTopView)
-	GlRenderer::SetupProjection(w, h, angle);
-  else {
-	glViewport(0, 0, w, h);
+///////////////////////////////////////////////////////////////
+///////////////////////////////////////////////////////////////
+///////////////////////////////////////////////////////////////
+///////////////////////////////////////////////////////////////
+
+
+
+
+
+void
+QtGlRendererWidget::SetupCameraProjection(const int w, const int h, const float angle)
+{
+  if (!mTopView) {
+	int ww = w;
+	int hh = h;
+	glViewport(0, 0, ww, hh);
 	glMatrixMode(GL_PROJECTION);
 	glLoadIdentity();
-	gluPerspective(50.0, 1.0, 0.1, 20.0*Magnitude(mSceneGraph->GetBox().Diagonal()));
+	gluPerspective(angle, ww/(float)hh, 0.1, 2.0*Magnitude(mSceneGraph->GetBox().Diagonal()));
 	glMatrixMode(GL_MODELVIEW);
-  }
-}
+  } else {
+	int ww = w;
+	int hh = h;
+	glViewport(0, 0, ww, hh);
+	glMatrixMode(GL_PROJECTION);
+	glLoadIdentity();
+	gluPerspective(50.0, ww/(float)hh, 0.1, 20.0*Magnitude(mSceneGraph->GetBox().Diagonal()));
+	glMatrixMode(GL_MODELVIEW);
+  }
+}
+
+
 
 void
 QtGlRendererWidget::RenderPvs()
 {
-  SetupCamera();
-  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
-  
+	
+  Intersectable::NewMail();
+
   ViewCell *viewcell = NULL;
 
   PrVs prvs;
   
-  if (!mUseFilter) {
+  if (1 || !mUseFilter) {
 	viewcell = mViewCellsManager->GetViewCell(mViewPoint, true);
   } else {
-	  //  mViewCellsManager->SetMaxFilterSize(1);
-	  mViewCellsManager->GetPrVS(mViewPoint, prvs, mViewCellsManager->GetFilterWidth());
-	  viewcell = prvs.mViewCell;
-  }
-
-  if (viewcell) 
-  {
-	  // copy the pvs so that it can be filtered...
-	  ObjectPvs pvs = viewcell->GetPvs();
-
+	//  mViewCellsManager->SetMaxFilterSize(1);
+	mViewCellsManager->GetPrVS(mViewPoint, prvs, mViewCellsManager->GetFilterWidth());
+	viewcell = prvs.mViewCell;
+  }
+  
+  if (viewcell) {
+	// copy the pvs so that it can be filtered...
+	
+	//	mPvsCache.mPvs;
+	
+	if (mPvsCache.mViewCell != viewcell) {
+	  mPvsCache.Reset();
+	  mPvsCache.mViewCell = viewcell;
+	  
 	  if (mUseSpatialFilter) {
-		  mViewCellsManager->ApplySpatialFilter(mKdTree,
-			  mSpatialFilterSize*
-			  Magnitude(mViewCellsManager->GetViewSpaceBox().Size()),
-			  pvs);
-	  }
-
-	  // read back the texture
-	  mPvsSize = pvs.GetSize();
-
-	  ObjectPvsIterator pit = pvs.GetIterator();
-
-	  while (pit.HasMoreEntries())
-	  {		
-		  const ObjectPvsEntry &entry = pit.Next();
-		  Intersectable *obj = entry.mObject;
-
-		  float visibility = log10(entry.mData.mSumPdf + 1) / 5.0f;
-		  glColor3f(visibility, 0.0f, 0.0f);
-		  mUseForcedColors = true;
-		  RenderIntersectable(obj);
-		  mUseForcedColors = false;
-	  }
-
-	  if (mRenderFilter) 
-	  {
-		  mWireFrame = true;
-		  RenderIntersectable(viewcell);
-		  mWireFrame = false;
-	  }
-
-	  if (mUseFilter)
-	  {
-		  mViewCellsManager->DeleteLocalMergeTree(viewcell);
-	  }
-  } 
-  else 
-  {
-	  ObjectContainer::const_iterator oi = mObjects.begin();
-	  for (; oi != mObjects.end(); oi++)
-		  RenderIntersectable(*oi);
+		// 9.11. 2006 -> experiment with new spatial filter
+#if 0
+		mViewCellsManager->ApplySpatialFilter(mKdTree,
+											  mSpatialFilterSize*
+											  Magnitude(mViewCellsManager->GetViewSpaceBox().Size()),
+											  mPvsCache.mPvs);
+#else
+		// mSpatialFilter size is in range 0.001 - 0.1
+		mViewCellsManager->ApplyFilter2(viewcell,
+										mUseFilter,
+										100*mSpatialFilterSize,
+										mPvsCache.mPvs,
+										&mPvsCache.filteredBoxes
+										);
+#endif
+	  } else
+		mPvsCache.mPvs = viewcell->GetPvs();
+	  
+	  emit PvsUpdated();
+	}
+
+	// Render PVS
+	if (mUseSpatialFilter && mRenderBoxes) {
+		for (int i=0; i < mPvsCache.filteredBoxes.size(); i++)
+			RenderBox(mPvsCache.filteredBoxes[i]);
+	} else {
+		ObjectPvsIterator it = mPvsCache.mPvs.GetIterator();
+		
+		mPvsSize = mPvsCache.mPvs.GetSize();
+		for (; it.HasMoreEntries(); ) {
+			ObjectPvsEntry entry = it.Next();
+			Intersectable *object = entry.mObject;
+			
+			if (mRenderVisibilityEstimates) {
+				
+				float visibility = mTransferFunction*log10(entry.mData.mSumPdf + 1); // /5.0f
+				glColor3f(visibility, 0.0f, 0.0f);
+				mUseForcedColors = true;
+				RenderIntersectable(object);
+				mUseForcedColors = false;
+			} else {
+				mUseForcedColors = false;
+				RenderIntersectable(object);
+			}
+		}
+	}
+
+	if (mRenderFilter) {
+	  mWireFrame = true;
+	  RenderIntersectable(viewcell);
+	  glPushMatrix();
+	  glTranslatef(mViewPoint.x, mViewPoint.y, mViewPoint.z);
+	  glScalef(5.0f,5.0f,5.0f);
+	  glPushAttrib(GL_CURRENT_BIT);
+	  glColor3f(1.0f, 0.0f, 0.0f);
+	  gluSphere((::GLUquadric *)mSphere,
+							1e-3*Magnitude(mViewCellsManager->GetViewSpaceBox().Size()), 6, 6);
+	  glPopAttrib();
+	  glPopMatrix();
+	  mWireFrame = false;
+	}
+	
+	if (0 && mUseFilter)
+	  mViewCellsManager->DeleteLocalMergeTree(viewcell);
+
+  } else {
+		ObjectContainer::const_iterator oi = mObjects.begin();
+		for (; oi != mObjects.end(); oi++)
+			RenderIntersectable(*oi);
   }
 }
@@ -1016,5 +439,4 @@
   mUseFalseColors = true;
 
-  SetupCamera();
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   
@@ -1154,4 +576,7 @@
   int x = e->pos().x();
   int y = e->pos().y();
+
+  int diffx = -(mousePoint.x - x);
+  int diffy = -(mousePoint.y - y);
   
   if (e->modifiers() & Qt::ControlModifier) {
@@ -1182,5 +607,5 @@
 QtGlRendererWidget::resizeGL(int w, int h)
 {
-  SetupProjection(w, h);
+  SetupCameraProjection(w, h);
   updateGL();
 }
@@ -1191,22 +616,20 @@
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
 
-  
-  if (!mRenderViewCells) {
-	if (mRenderErrors)
+  if (1) {
+	SetupCameraProjection(width(), height());
+	SetupCamera();
+	
+	if (mRenderErrors) {
 	  RenderErrors();
-	else
+	} else {
 	  RenderPvs();
-	RenderInfo();
-  } else {
-	RenderViewCells();
-	
-	mWireFrame = true;
-	RenderScene();
-	mWireFrame = false;
-	
-	RenderInfo();
-  }
+	}
+	
+  }
+
+  RenderInfo();
 
   mFrame++;
+  
 }
 
@@ -1250,4 +673,5 @@
 }
 
+
 void
 QtGlRendererWidget::keyPressEvent ( QKeyEvent * e )
@@ -1256,5 +680,5 @@
   case Qt::Key_T:
 	mTopView = !mTopView;
-	SetupProjection(width(), height());
+	SetupCameraProjection(width(), height());
 	updateGL();
 	break;
@@ -1277,14 +701,16 @@
   
 
-QtGlRendererWidget::QtGlRendererWidget(SceneGraph *sceneGraph,
-								   ViewCellsManager *viewcells,
-								   KdTree *tree,
-								   QWidget * parent,
-								   const QGLWidget * shareWidget,
-								   Qt::WFlags f
-								   )
+QtGlRendererWidget::QtGlRendererWidget(
+									   SceneGraph *sceneGraph,
+									   ViewCellsManager *viewcells,
+									   KdTree *tree,
+									   QWidget * parent,
+									   const QGLWidget * shareWidget,
+									   Qt::WFlags f
+									   )
   :
   GlRendererWidget(sceneGraph, viewcells, tree), QGLWidget(parent, shareWidget, f)
 {
+  mPreprocessorThread = NULL;
   mTopView = false;
   mRenderViewCells = false;
@@ -1293,5 +719,8 @@
   mCutScene = false;
   mRenderErrors = false;
+  mRenderBoxes = false;
   mRenderFilter = true;
+  mRenderVisibilityEstimates = false;
+  mTransferFunction = 0.2f;
 
   bool tmp;
@@ -1302,5 +731,4 @@
   Environment::GetSingleton()->GetBoolValue("Preprocessor.applyVisibilitySpatialFilter",
 							tmp );
-
   mUseSpatialFilter = tmp;
 
@@ -1310,7 +738,19 @@
   mPvsSize = 0;
   mRenderError = 0.0f;
+  mShowRays = false;
+  
   mControlWidget = new QtRendererControlWidget(NULL);
   
   connect(mControlWidget, SIGNAL(SetViewCellGranularity(int)), this, SLOT(SetViewCellGranularity(int)));
+  connect(mControlWidget,
+		  SIGNAL(SetTransferFunction(int)),
+		  this,
+		  SLOT(SetTransferFunction(int)));
+  connect(mControlWidget, SIGNAL(UpdateAllPvs()), this, SLOT(UpdateAllPvs()));
+  connect(mControlWidget, SIGNAL(ComputeVisibility()), this, SLOT(ComputeVisibility()));
+  connect(mControlWidget, SIGNAL(StopComputation()), this, SLOT(StopComputation()));
+  connect(mControlWidget, SIGNAL(SetRandomViewPoint()), this,
+		  SLOT(SetRandomViewPoint()));
+
   connect(mControlWidget, SIGNAL(SetSceneCut(int)), this, SLOT(SetSceneCut(int)));
   connect(mControlWidget, SIGNAL(SetTopDistance(int)), this, SLOT(SetTopDistance(int)));
@@ -1326,46 +766,55 @@
   connect(mControlWidget, SIGNAL(SetCutScene(bool)), this, SLOT(SetCutScene(bool)));
   connect(mControlWidget, SIGNAL(SetRenderErrors(bool)), this, SLOT(SetRenderErrors(bool)));
+  connect(mControlWidget, SIGNAL(SetRenderBoxes(bool)), this, SLOT(SetRenderBoxes(bool)));
   connect(mControlWidget, SIGNAL(SetRenderFilter(bool)), this, SLOT(SetRenderFilter(bool)));
+  connect(mControlWidget, SIGNAL(SetRenderVisibilityEstimates(bool)),
+		  this, SLOT(SetRenderVisibilityEstimates(bool)));
   connect(mControlWidget, SIGNAL(SetUseFilter(bool)), this, SLOT(SetUseFilter(bool)));
   connect(mControlWidget, SIGNAL(SetUseSpatialFilter(bool)),
 		  this, SLOT(SetUseSpatialFilter(bool)));
 
-  
+  connect(mControlWidget,
+		  SIGNAL(SetShowRays(bool)),
+		  this,
+		  SLOT(SetShowRays(bool)));
+
+  resize(1000, 500);
   mControlWidget->show();
 }
 
-
-void
-QtGlRendererWidget::RenderInfo()
-{
-  QString s;
-  int vc = 0;
-  
-  if (mViewCellsManager)
-	  vc = (int)mViewCellsManager->GetViewCells().size();
-
-  int filter = 0;
-  if (mViewCellsManager)
-	filter = mViewCellsManager->GetMaxFilterSize();
-
-  s.sprintf("frame:%04d viewpoint:(%4.1f,%4.1f,%4.1f) dir:(%4.1f,%4.1f,%4.1f) viewcells:%04d filter:%04d pvs:%04d error:%5.5f %",
-			mFrame,
-			mViewPoint.x,
-			mViewPoint.y,
-			mViewPoint.z,
-			mViewDirection.x,
-			mViewDirection.y,
-			mViewDirection.z,
-			vc,
-
-			filter,
-			mPvsSize,
-			mRenderError*100.0f
-			);
-  
-  glColor3f(0.0f,0.0f,0.0f);
-  renderText(0,20,s);
-  
-  if (mShowRenderCost) {
+void
+QtGlRendererWidget::UpdateAllPvs()
+{
+  // $$ does not work so far:(
+  mViewCellsManager->UpdatePvsForEvaluation();
+  //	mViewCellsManager->FinalizeViewCells(false);
+}
+
+void
+QtGlRendererWidget::ComputeVisibility()
+{
+  cerr<<"Compute Visibility called!\n"<<endl;
+  if (!mPreprocessorThread->isRunning())
+	mPreprocessorThread->RunThread();
+}
+
+void
+QtGlRendererWidget::StopComputation()
+{
+  cerr<<"stop computation called!\n"<<endl;
+  mViewCellsManager->GetPreprocessor()->mStopComputation = true;
+}
+
+void
+QtGlRendererWidget::SetRandomViewPoint()
+{
+  cerr<<"stop computation called!\n"<<endl;
+  mViewCellsManager->GetViewPoint(mViewPoint);
+  updateGL();
+}
+
+void
+QtGlRendererWidget::RenderRenderCost()
+{
 	static vector<float> costFunction;
 	static float maxCost = -1;
@@ -1377,4 +826,6 @@
 		for (int i=0;  i < costFunction.size(); i++) {
 		  //		  cout<<i<<":"<<costFunction[i]<<" ";
+		  // update cost function to an absolute value based on the total geometry count
+		  costFunction[i]*=mSceneGraph->GetRoot()->mGeometry.size();
 		  if (costFunction[i] > maxCost)
 			maxCost = costFunction[i];
@@ -1389,5 +840,5 @@
 	if (currentPos < costFunction.size())
 	  currentCost = costFunction[currentPos];
-#if 0	
+#if 1	
 	cout<<"costFunction.size()="<<costFunction.size()<<endl;
 	cout<<"CP="<<currentPos<<endl;
@@ -1396,7 +847,11 @@
 #endif
 	if (costFunction.size()) {
+	  float scaley = 1.0f/log10(maxCost);
+	  float scalex = 1.0f/(float)costFunction.size();
+
 	  glDisable(GL_DEPTH_TEST);
 	  // init ortographic projection
 	  glMatrixMode(GL_PROJECTION);
+	  
 	  glPushMatrix();
 	  
@@ -1414,6 +869,6 @@
 	  
 	  for (int i=0;  i < costFunction.size(); i++) {
-		float x =  i/(float)costFunction.size();
-		float y = costFunction[i]/(maxCost*0.5f);
+		float x =  i*scalex;
+		float y = log10(costFunction[i])*scaley;
 		glVertex3f(x,y,0.0f);
 	  }
@@ -1422,5 +877,5 @@
 	  glColor3f(1.0f,0,0);
 	  glBegin(GL_LINES);
-	  float x =  currentPos/(float)costFunction.size();
+	  float x =  currentPos*scalex;
 	  glVertex3f(x,0.0,0.0f);
 	  glVertex3f(x,1.0f,0.0f);
@@ -1437,14 +892,17 @@
 
 	  glBegin(GL_LINES);
-	  for (int i=0;  i < 50000 && i < costFunction.size(); i+=10000) {
-		float x =  i/(float)costFunction.size();
+	  for (int i=0;  i < costFunction.size(); i += 1000) {
+		float x =  i*scalex;
 		glVertex3f(x,0.0,0.0f);
 		glVertex3f(x,1.0f,0.0f);
 	  }
 
-	  for (int i=0;  i < maxCost; i+=100) {
-		float y = i/(maxCost*0.5f);
-		glVertex3f(0,y,0.0f);
-		glVertex3f(1,y,0.0f);
+	  for (int i=0;  pow(10.0f, i) < maxCost; i+=1) {
+		float y = i*scaley;
+		//		QString s;
+		//		s.sprintf("%d", (int)pow(10,i));
+		//		renderText(width()/2+5, y*height(), s);
+		glVertex3f(0.0f, y, 0.0f);
+		glVertex3f(1.0f, y, 0.0f);
 	  }
 
@@ -1459,5 +917,47 @@
 
 	}
-  }
+  
+
+
+}
+
+void
+QtGlRendererWidget::RenderInfo()
+{
+  
+  QString s;
+  int vc = 0;
+  if (mViewCellsManager)
+	vc = mViewCellsManager->GetViewCells().size();
+  int filter = 0;
+  if (mViewCellsManager)
+	filter = mViewCellsManager->GetMaxFilterSize();
+
+  glColor3f(1.0f,1.0f,1.0f);
+
+  s.sprintf("frame:%04d viewpoint:(%4.1f,%4.1f,%4.1f) dir:(%4.1f,%4.1f,%4.1f)",
+			mFrame,
+			mViewPoint.x,
+			mViewPoint.y,
+			mViewPoint.z,
+			mViewDirection.x,
+			mViewDirection.y,
+			mViewDirection.z
+			);
+
+  renderText(20,20,s);
+
+  s.sprintf("viewcells:%04d filter:%04d pvs:%04d error:%5.5f\%",
+			vc,
+			filter,
+			mPvsSize,
+			mRenderError*100.0f);
+
+
+  renderText(20,40,s);
+
+  
+
+  
 }
 
@@ -1466,8 +966,12 @@
 QtGlRendererWidget::SetViewCellGranularity(int number)
 {
-  if (mViewCellsManager) 
+  if (mViewCellsManager) {
 	//  	mViewCellsManager->SetMaxFilterSize(number);
     mViewCellsManager->CollectViewCells(number);
 
+	// $$ does not work so far:(
+	//	mViewCellsManager->UpdatePvsForEvaluation();
+	//	mViewCellsManager->FinalizeViewCells(false);
+  }
   updateGL();
 }
@@ -1478,4 +982,5 @@
   if (mViewCellsManager) 
   	mViewCellsManager->SetMaxFilterSize(number);
+  mPvsCache.Reset();
   updateGL();
 }
@@ -1485,4 +990,5 @@
 {
   mSpatialFilterSize = 1e-3*number;
+  mPvsCache.Reset();
   updateGL();
 }
@@ -1513,57 +1019,61 @@
 QtGlRendererWidget::RenderViewCells()
 {
-	mUseFalseColors = true;
-
-	SetupCamera();
-	glEnable(GL_CULL_FACE);
-	//glDisable(GL_CULL_FACE);
-	glCullFace(GL_FRONT);
-	double eq[4];
-	eq[0] = mSceneCutPlane.mNormal.x;
-	eq[1] = mSceneCutPlane.mNormal.y;
-	eq[2] = mSceneCutPlane.mNormal.z;
-	eq[3] = mSceneCutPlane.mD;
-
-	if (mCutViewCells) 
-	{
-		glClipPlane(GL_CLIP_PLANE0, eq);
-		glEnable(GL_CLIP_PLANE0);
+  mUseFalseColors = true;
+
+  glPushAttrib(GL_CURRENT_BIT | GL_ENABLE_BIT | GL_POLYGON_BIT);
+  
+  glEnable(GL_CULL_FACE);
+  //glDisable(GL_CULL_FACE);
+  glCullFace(GL_FRONT);
+  double eq[4];
+  eq[0] = mSceneCutPlane.mNormal.x;
+  eq[1] = mSceneCutPlane.mNormal.y;
+  eq[2] = mSceneCutPlane.mNormal.z;
+  eq[3] = mSceneCutPlane.mD;
+
+  if (mCutViewCells) {
+	glClipPlane(GL_CLIP_PLANE0, eq);
+	glEnable(GL_CLIP_PLANE0);
+  }
+  
+  int i;
+  ViewCellContainer &viewcells = mViewCellsManager->GetViewCells();
+  int maxPvs = -1;
+  for (i=0; i < viewcells.size(); i++) 
+  {
+	ViewCell *vc = viewcells[i];
+
+	//const int p = vc->GetPvs().CountObjectsInPvs();
+	const int p = vc->GetPvs().GetSize();
+	if (p > maxPvs)
+	  maxPvs = p;
+  }
+
+
+  for (i=0; i < viewcells.size(); i++) {
+	ViewCell *vc = viewcells[i];
+	//	Mesh *m = vc->GetMesh();
+
+
+	RgbColor c;
+
+	if (!mShowPvsSizes) {
+	  mWireFrame = true;
+	  c = vc->GetColor();
+	} else {
+	  //	  const float importance = 5.0f*mTransferFunction * ((float)vc->GetPvs().CountObjectsInPvs() / (float)maxPvs);
+	  const float importance = 5.0f*mTransferFunction * ((float)vc->GetPvs().GetSize() / (float)maxPvs);
+	  c = RgbColor(importance, 1.0f - importance, 0.0f);
 	}
-
-	//int i;
-	ViewCellContainer &viewCells = mViewCellsManager->GetViewCells();
-	float maxPvs = -1;
-	ViewCellContainer::const_iterator vit, vit_end = viewCells.end();
-
-	for (vit = viewCells.begin(); vit != vit_end; ++ vit)
-	{
-		ViewCell *vc = *vit;
-		const float p = vc->GetPvs().EvalPvsCost();
-		if (p > maxPvs)
-			maxPvs = p;
-	}
-
-	for (vit = viewCells.begin(); vit != vit_end; ++ vit) 
-	{
-		ViewCell *vc = *vit;
-
-		RgbColor c;
-
-		if (!mShowPvsSizes) 
-		{
-			c = vc->GetColor();
-		}
-		else 
-		{
-			const float importance = (float)vc->GetPvs().EvalPvsCost() / (float)maxPvs;
-			c = RgbColor(importance, 1.0f - importance, 0.0f);
-		}
-
-		glColor3f(c.r, c.g, c.b);
-
-		RenderViewCell(vc);
-	}
-
-	glDisable(GL_CLIP_PLANE0);
+	glColor3f(c.r, c.g, c.b);
+	
+	RenderViewCell(vc);
+  }
+
+  mUseFalseColors = false;
+  mWireFrame = false;
+
+  glPopAttrib();
+  
 }
 
@@ -1573,5 +1083,5 @@
 
 /***********************************************************************/
-/*                     QtGlDebuggerWidget implementation			   */
+/*                     QtGlDebuggerWidget implementation				   */
 /***********************************************************************/
 
@@ -1612,5 +1122,5 @@
   QLabel *label = new QLabel("Granularity");
   vbox->layout()->addWidget(label);
-
+  
   QSlider *slider = new QSlider(Qt::Horizontal, vbox);
   vl->addWidget(slider);
@@ -1620,6 +1130,27 @@
   slider->setValue(200);
 
+  
   connect(slider, SIGNAL(valueChanged(int)), SIGNAL(SetViewCellGranularity(int)));
 
+  label = new QLabel("Transfer function");
+  vbox->layout()->addWidget(label);
+  
+  slider = new QSlider(Qt::Horizontal, vbox);
+  vl->addWidget(slider);
+  slider->show();
+  slider->setRange(1, 1000);
+  slider->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Preferred);
+  slider->setValue(100);
+
+  
+  connect(slider, SIGNAL(valueChanged(int)), SIGNAL(SetTransferFunction(int)));
+
+  {
+	QPushButton *button = new QPushButton("Update all PVSs", vbox);
+	vbox->layout()->addWidget(button);
+	connect(button, SIGNAL(clicked()), SLOT(UpdateAllPvs()));
+  }
+  
+  
   label = new QLabel("Filter size");
   vbox->layout()->addWidget(label);
@@ -1659,13 +1190,18 @@
   connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetShowViewCells(bool)));
 
+  cb = new QCheckBox("Render cost curve", hbox);
+  hlayout->addWidget(cb);
+  cb->setChecked(false);
+  connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetShowRenderCost(bool)));
+
   cb = new QCheckBox("Show render cost", hbox);
   hlayout->addWidget(cb);
   cb->setChecked(false);
-  connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetShowRenderCost(bool)));
-
-  cb = new QCheckBox("Show pvs sizes", hbox);
+  connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetShowPvsSizes(bool)));
+
+  cb = new QCheckBox("Show rays", hbox);
   hlayout->addWidget(cb);
   cb->setChecked(false);
-  connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetShowPvsSizes(bool)));
+  connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetShowRays(bool)));
 
   vbox->resize(800,100);
@@ -1678,4 +1214,10 @@
   vbox->setLayout(vl);
 
+
+
+  cb = new QCheckBox("Cut view cells", vbox);
+  vbox->layout()->addWidget(cb);
+  cb->setChecked(false);
+  connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetCutViewCells(bool)));
 
 
@@ -1689,4 +1231,21 @@
   connect(slider, SIGNAL(valueChanged(int)), SIGNAL(SetSceneCut(int)));
 
+
+  cb = new QCheckBox("Cut scene", vbox);
+  vbox->layout()->addWidget(cb);
+  cb->setChecked(false);
+  connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetCutScene(bool)));
+
+  cb = new QCheckBox("Render boxes", vbox);
+  vbox->layout()->addWidget(cb);
+  cb->setChecked(false);
+  connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetRenderBoxes(bool)));
+
+  cb = new QCheckBox("Render visibility estimates", vbox);
+  vbox->layout()->addWidget(cb);
+  cb->setChecked(false);
+  connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetRenderVisibilityEstimates(bool)));
+
+  
   cb = new QCheckBox("Render errors", vbox);
   vbox->layout()->addWidget(cb);
@@ -1694,12 +1253,19 @@
   connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetRenderErrors(bool)));
 
+  
+  bool tmp;
+
   cb = new QCheckBox("Use filter", vbox);
   vbox->layout()->addWidget(cb);
-  cb->setChecked(true);
+  Environment::GetSingleton()->GetBoolValue("Preprocessor.applyVisibilityFilter", tmp );
+  cb->setChecked(tmp);
   connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetUseFilter(bool)));
 
+  
   cb = new QCheckBox("Use spatial filter", vbox);
   vbox->layout()->addWidget(cb);
-  cb->setChecked(true);
+  Environment::GetSingleton()->GetBoolValue("Preprocessor.applyVisibilitySpatialFilter",
+											tmp );
+  cb->setChecked(tmp);
   connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetUseSpatialFilter(bool)));
 
@@ -1710,13 +1276,4 @@
 
 
-  cb = new QCheckBox("Cut view cells", vbox);
-  vbox->layout()->addWidget(cb);
-  cb->setChecked(false);
-  connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetCutViewCells(bool)));
-
-  cb = new QCheckBox("Cut scene", vbox);
-  vbox->layout()->addWidget(cb);
-  cb->setChecked(false);
-  connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetCutScene(bool)));
 
   
@@ -1735,22 +1292,45 @@
   connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetTopView(bool)));
 
+
+
   vbox = new QGroupBox("PVS Errors", this);
   layout()->addWidget(vbox);
-
+  
   vl = new QVBoxLayout;
   vbox->setLayout(vl);
 
-  mPvsErrorWidget = new QListWidget(vbox);
-  vbox->layout()->addWidget(mPvsErrorWidget);
-  
-  connect(mPvsErrorWidget,
-  		  SIGNAL(doubleClicked(const QModelIndex &)),
-  		  this,
-  		  SLOT(PvsErrorClicked(const QModelIndex &)));
-  
-  QPushButton *button = new QPushButton("Next Error Frame", vbox);
+  QPushButton *button = new QPushButton("Compute Visibility", vbox);
   vbox->layout()->addWidget(button);
-  connect(button, SIGNAL(clicked(void)), SLOT(FocusNextPvsErrorFrame(void)));
-
+  connect(button, SIGNAL(clicked()), SLOT(ComputeVisibility()));
+
+  button = new QPushButton("Stop Computation", vbox);
+  vbox->layout()->addWidget(button);
+  connect(button, SIGNAL(clicked()), SLOT(StopComputation()));
+
+  button = new QPushButton("Set Random View Point", vbox);
+  vbox->layout()->addWidget(button);
+  connect(button, SIGNAL(clicked()), SLOT(SetRandomViewPoint()));
+
+
+  if (0) {
+	vbox = new QGroupBox("PVS Errors", this);
+	layout()->addWidget(vbox);
+	
+	vl = new QVBoxLayout;
+	vbox->setLayout(vl);
+	
+	mPvsErrorWidget = new QListWidget(vbox);
+	vbox->layout()->addWidget(mPvsErrorWidget);
+	
+	connect(mPvsErrorWidget,
+			SIGNAL(doubleClicked(const QModelIndex &)),
+			this,
+			SLOT(PvsErrorClicked(const QModelIndex &)));
+	
+	QPushButton *button = new QPushButton("Next Error Frame", vbox);
+	vbox->layout()->addWidget(button);
+	connect(button, SIGNAL(clicked(void)), SLOT(FocusNextPvsErrorFrame(void)));
+  }
+  
   setWindowTitle("Preprocessor Control Widget");
   adjustSize();
@@ -1758,4 +1338,6 @@
 
 
+
+
 void
 QtRendererControlWidget::FocusNextPvsErrorFrame(void)
@@ -1767,5 +1349,5 @@
 void
 QtRendererControlWidget::UpdatePvsErrorItem(int row,
-											GlRendererBuffer::PvsErrorEntry &pvsErrorEntry)
+										  GlRendererBuffer::PvsErrorEntry &pvsErrorEntry)
 {
 
